"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CategoryService = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("mongoose");
const mongoose_2 = require("@nestjs/mongoose");
const category_schema_1 = require("../schemas/category.schema");
let CategoryService = class CategoryService {
    constructor(categoryModel) {
        this.categoryModel = categoryModel;
    }
    async create(category) {
        const existingCategory = await this.categoryModel
            .findOne({ name: category.name })
            .exec();
        if (existingCategory) {
            throw new common_1.ConflictException("Category name already exists");
        }
        const createdCategory = new this.categoryModel(category);
        return createdCategory.save();
    }
    async getAllCategories() {
        return this.categoryModel.find().exec();
    }
    async getAllCategoriesByStatus(status) {
        return this.categoryModel.find({ status }).exec();
    }
    async getCategoryById(id) {
        const category = await this.categoryModel.findById(id).exec();
        if (!category) {
            throw new common_1.NotFoundException("Category not found");
        }
        return category;
    }
    async update(id, updatedCategory) {
        const existingCategory = await this.categoryModel
            .findOne({ name: updatedCategory.name, _id: { $ne: id } })
            .exec();
        if (existingCategory) {
            throw new common_1.ConflictException("Category name already exists");
        }
        const updateCagetory = await this.categoryModel
            .findByIdAndUpdate(id, updatedCategory, { new: true })
            .exec();
        if (!updateCagetory) {
            throw new common_1.NotFoundException(`Category with ID ${id} not found`);
        }
        return updateCagetory;
    }
    async delete(id) {
        const deletedCategory = await this.categoryModel
            .findOneAndDelete({ _id: id })
            .exec();
        if (!deletedCategory) {
            throw new common_1.NotFoundException("Category not found");
        }
    }
};
CategoryService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_2.InjectModel)(category_schema_1.Category.name)),
    __metadata("design:paramtypes", [mongoose_1.Model])
], CategoryService);
exports.CategoryService = CategoryService;
//# sourceMappingURL=category.service.js.map