import { Model } from 'mongoose';
import { CourseRoutine, CourseRoutineDocument } from 'src/schemas/courseRoutine.schema';
export declare class CourseRoutineService {
    private courseRoutineModel;
    constructor(courseRoutineModel: Model<CourseRoutineDocument>);
    create(courseRoutine: CourseRoutine): Promise<CourseRoutine>;
    edit(courseRoutineId: string, updatedCourseRoutine: CourseRoutine): Promise<CourseRoutine>;
    findAll(): Promise<CourseRoutine[]>;
    findById(courseRoutineId: string): Promise<CourseRoutine>;
    getByCourseId(courseId: string): Promise<CourseRoutine | null>;
    delete(courseRoutineId: string): Promise<void>;
    checkCourseRoutineNameNotExists(name: string, courseId: any, excludedCourseRoutineId?: string): Promise<void>;
}
