"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FeedbackService = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const feedback_schema_1 = require("../schemas/feedback.schema");
let FeedbackService = class FeedbackService {
    constructor(feedbackModel) {
        this.feedbackModel = feedbackModel;
    }
    async create(feedback) {
        const createdFeedback = new this.feedbackModel(feedback);
        return createdFeedback.save();
    }
    async edit(feedbackId, updatedFeedback) {
        const existingFeedback = await this.feedbackModel.findByIdAndUpdate(feedbackId, updatedFeedback, {
            new: true
        }).exec();
        if (!existingFeedback) {
            throw new common_1.NotFoundException(`Feedback with ID ${feedbackId} not found`);
        }
        return existingFeedback;
    }
    async getAll() {
        return this.feedbackModel.find().exec();
    }
    async getFeedbackByStatus(status) {
        return this.feedbackModel.find({ status }).exec();
    }
    async getById(feedbackId) {
        const feedback = await this.feedbackModel.findById(feedbackId).exec();
        if (!feedback) {
            throw new common_1.NotFoundException(`Feedback with id ${feedbackId} not found`);
        }
        return feedback;
    }
    async getByUserId(userId) {
        return this.feedbackModel.find({ userId }).exec();
    }
    async getByCourseId(courseId) {
        return this.feedbackModel.find({ courseId }).exec();
    }
    async delete(feedbackId) {
        await this.getById(feedbackId);
        await this.feedbackModel.findByIdAndDelete(feedbackId).exec();
    }
};
FeedbackService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(feedback_schema_1.Feedback.name)),
    __metadata("design:paramtypes", [mongoose_2.Model])
], FeedbackService);
exports.FeedbackService = FeedbackService;
//# sourceMappingURL=feedback.service.js.map