import { Model } from "mongoose";
import { Lesson, LessonDocument } from "src/schemas/lesson.schema";
import { CloudinaryService } from "./cloudinary.service";
export declare class LessonService {
    private lessonModel;
    private readonly cloudinaryService;
    constructor(lessonModel: Model<LessonDocument>, cloudinaryService: CloudinaryService);
    create(lesson: Lesson): Promise<Lesson>;
    edit(lessonId: string, updatedLesson: Lesson): Promise<Lesson>;
    getAll(): Promise<Lesson[]>;
    getById(lessonId: string): Promise<Lesson>;
    getBySectionId(sectionId: string): Promise<Lesson[]>;
    getSectionById(sectionId: string): Promise<Lesson[]>;
    delete(lessonId: string): Promise<void>;
    private checkLessonNameNotExists;
    getTotalLessons(): Promise<number>;
}
